<?php

	// Include the configuration file
	include_once 'config-%_weaverfm-uniqueid_%.php';
	
	// Include the utils file
	include_once 'utils-%_weaverfm-uniqueid_%.php';
	
	// Get the cookies from the request
	$cookie_jar = cookieArray();
	
	// If Cookies is not set, exit
	if(count($cookie_jar) == 0) exit;
	
	// Verify the cookie
	$monster = verifyCookieArray($cookie_jar);
		
	// The response to feed back to the browser
	$response = array('WFM_LOGIN_RESULT' => false);
	
	// If the cookie verified successfully
	if($monster) {
		
		// Login was successful
		$response['WFM_LOGIN_RESULT'] = true;
		
		// The user we will be referring to
		$user = cookieUsername();
		
		// Properties
		$response['WFM_MAX_UPLOAD_SIZE'] = min(return_bytes(ini_get('post_max_size')), return_bytes(ini_get('upload_max_filesize')));
		
		// User permissions
		$upload = userCanUpload($user);
		$download = userCanDownload($user);
		$destroy = userCanDestroy($user);
		$permissions = array('WFM_UPLOAD_PERMISSIONS' => $upload,
							 'WFM_DOWNLOAD_PERMISSIONS' => $download,
							 'WFM_DESTROY_PERMISSIONS' => $destroy);
							
		$response['WFM_USER_PERMISSIONS'] = $permissions;
		
		// Update the session
		//setCookieSessionArray($cookie_jar);
	}
	
	// Echo the response
	echo(json_encode($response));
?>