<?php

	// If the POST is empty immediately exit
	if(empty($_POST)) exit;

	// Include all utility functions
	include_once 'utils-%_weaverfm-uniqueid_%.php';
	
	// Include all the users and groups
	include_once 'accounts-%_weaverfm-uniqueid_%.php';
	
	// Include the configuration script
	include_once 'config-%_weaverfm-uniqueid_%.php';
	
	function credentialsForUser($username = '', $password = '') {
		
		// Use the expiration as defined in the config.php
		global $expiration;
		
		// The cookie for the user
		$cookie = '';
		
		// The number of days until expiration (default: 0)
		$exp = 0;
		
		// The date the cookie was issued (default: now)
		$issued_on = time();
		
		// Verify the login and password
		if(verifyLogin($username, $password, sessionChallenge())) {
			
			// Generate a cookie for the user
			$cookie = generateCookieForUser($username, $issued_on);
			
			// If the user would like to be remembered, store the cookie for
			// $expiration number of days
			if(sessionAutologin()) {
				$exp = 60*60*24*$expiration;
			}
		}
		
		// Return the credentials
		return array('Cookie' => $cookie, 'Expiration' => $exp, 'IssuedOn' => $issued_on);
	}
	
	// Login with the username and password. Return true if the cookie is not empty
	function login($username = '', $pw = '') {
		
		// Get the user credentials
		$credentials = credentialsForUser($username, $pw);
		
		// Get the cookie
		$cookie = $credentials['Cookie'];
		
		// Get the expiration
		$expiration = $credentials['Expiration'];
		
		// Get the issued on date
		$issued_on = $credentials['IssuedOn'];
		
		// Set the cookie
		setSessionCookie($cookie);
		
		// Set the username
		setSessionUsername($username);
		
		// Set the issued on
		setSessionIssuedOn($issued_on);
		
		// Set the $_COOKIE
		setcookie($username, $cookie, $issued_on + $expiration);
		
		// If the cookie is not empty the login was successful
		return !empty($cookie);
	}
	
	// Set the session's challenge
	setSessionChallenge($_POST['wfm_challenge']);
	
	// Set the autologin flag
	$autologin = isset($_POST['wfm_autologin']) ? true : false;
	setSessionAutologin($autologin);
	
	// The login result
	$login = array('WFM_LOGIN_RESULT' => false);
	
	// Login!
	if(isset($_POST['wfm_username']) && 
		isset($_POST['wfm_password']) && 
		login($_POST['wfm_username'], $_POST['wfm_password'])) {
		
		// The user we will be referring to
		$user = $_POST['wfm_username'];

		// If the login is valid
		$login['WFM_LOGIN_RESULT'] = true;
		$login['WFM_LOGIN_COOKIE'] = sessionCookie();
		$login['WFM_COOKIE_DURATION'] = (sessionAutologin() ? $expiration : 0);
		$login['WFM_COOKIE_ISSUED_ON'] = sessionIssuedOn();
		$login['WFM_LOGIN_LANGUAGE'] = languageForUser($user);
		$login['WFM_MAX_UPLOAD_SIZE'] = min(return_bytes(ini_get('post_max_size')), return_bytes(ini_get('upload_max_filesize')));

		// User permissions
		$upload = userCanUpload($user);
		$download = userCanDownload($user);
		$destroy = userCanDestroy($user);
		$permissions = array('WFM_UPLOAD_PERMISSIONS' => $upload,
							 'WFM_DOWNLOAD_PERMISSIONS' => $download,
							 'WFM_DESTROY_PERMISSIONS' => $destroy);
		$login['WFM_USER_PERMISSIONS'] = $permissions;
	}
	
	// Echo the result of the login
	echo(json_encode($login));
?>