<?php

	// Include the configuration file
	include_once 'config-%_weaverfm-uniqueid_%.php';
	
	// Include the utils file
	include_once 'utils-%_weaverfm-uniqueid_%.php';
	
	// Include WFMUpload for mime type recognition
	include_once 'WFMUpload.php';
	
	require_once('class.phpmailer.php');
	
	// Define the messages
	$messages = %_weaverfm-messages_%;
	
	function sendDownloadNotificationEmail($toUser, $fileName, $extension, $uploadedBy) {
		
		// Referring to the global instance here
		global $messages;
		
		// Get the properties for the user
		$properties = propertiesForUser($toUser);
		
		// Get the email for the user
		$destination = emailForUser($toUser);
		
		// The message to send
		$message = $messages['download'];
		
		// If the email isn't empty
		if (!empty($destination) and !empty($message)) {
			
			// Get the first name of the user
			$firstname = firstNameOfUser($toUser);
			
			// Get the first name of the user
			$lastname = lastNameOfUser($toUser);
			
			// The source
			$source = $message['sender'];
			$source_firstname = $message['firstname'];
			$source_lastname = $message['lastname'];
			
			// The message body
			$messageBody = $message['body'];
			
			// Message attachments
			$files = $message['attachments'];
			
			// The subject of the message
			$subject = $message['subject'];
			
			$keywords = array('[firstname]' => $firstname,
							  '[lastname]' => $lastname,
							  '[filename]' => $fileName,
							  '[ext]' => $extension,
							  '[date]' => date('F j, Y'),
							  '[time]' => date('G:i:s T'),
							  '[datetime]' => date('D M j Y G:i:s T')
							  );
			
			if (!sendMessage($source,
							 $source_firstname,
							 $source_lastname,
							 $destination,
							 $firstname,
							 $lastname,
							 $subject,
							 $messageBody,
							 $files,
							 $keywords)) {
				// Log an error if the email wasn't sent
				error_log('weaverFM error! Unable to send download notification to '.$destination);	
			}
		}
	}
	
	
	function sendUploadNotificationEmail($toUser, $fileName, $extension, $uploadedBy) {
		
		// Referring to the global instance here
		global $messages;
		
		// Get the properties for the user
		$properties = propertiesForUser($toUser);
		
		// Get the email for the user
		$destination = emailForUser($toUser);
		
		// The message to send
		$message = $messages['upload'];
		
		// If the email isn't empty
		if (!empty($destination) and !empty($message)) {
			
			// Get the first name of the user
			$firstname = firstNameOfUser($toUser);

			// Get the first name of the user
			$lastname = lastNameOfUser($toUser);
			
			// The source
			$source = $message['sender'];
			$source_firstname = $message['firstname'];
			$source_lastname = $message['lastname'];
			
			// The message body
			$messageBody = $message['body'];

			// Message attachments
			$files = $message['attachments'];
			
			// The subject of the message
			$subject = $message['subject'];
			
			// The information for the uploader
			$uploader_firstname = firstNameOfUser($uploadedBy);
			$uploader_lastname = lastNameOfUser($uploadedBy);
			
			$keywords = array('[firstname]' => $firstname,
							  '[lastname]' => $lastname,
							  '[filename]' => $fileName,
							  '[uploader_firstname]' => $uploader_firstname,
							  '[uploader_lastname]' => $uploader_lastname,
							  '[ext]' => $extension,
							  '[date]' => date('F j, Y'),
							  '[time]' => date('G:i:s T'),
							  '[datetime]' => date('D M j Y G:i:s T')
			);
			
			if (!sendMessage($source,
				$source_firstname,
				$source_lastname,
				$destination,
				$firstname,
				$lastname,
				$subject,
				$messageBody,
				$files,
				$keywords)) {
				// Log an error if the email wasn't sent
				error_log('weaverFM error! Unable to send upload notification to '.$destination);	
			}
		}
	}
	
	// Sends a message
	function sendMessage($fromEmail = '',
						 $fromFirstName = '',
						 $fromLastName = '',
						 $toEmail = '',
						 $toFirstName = '',
						 $toLastName = '',
						 $subject  = '',
						 $body = '',
						 $files = array(),
						 $keywords = array()) {
		
		// The message body
		$messageBody = $body;

		// Replace each key with the appropriate value
		foreach ($keywords as $key => $value) {
			$messageBody = str_replace($key, $value, $messageBody);
		}
		
		// Construct the message
		$mail = new PHPMailer();
		$mail->Subject = $subject;
		$mail->SetFrom($fromEmail, $fromFirstName.' '.$fromLastName);
		$mail->AddAddress($toEmail, $toFirstName.' '.$toLastName);
		$mail->MsgHTML($messageBody);
		$mail->IsHTML(true);
		$mail->CharSet = 'UTF-8';

		// Add any necessary attachments
		foreach ($files as $file) {
			error_log('file: '.$file.' mime: '.WFMUpload::mime($file));
			if(!$mail->AddAttachment($file, $file, WFMUpload::mime($file))) {
				error_log('weaverFM error: Unable to attach file to email!');
			}
		}					
		
		// Return if the mail sent successfully
		return $mail->Send();					
	}
?>