<?php
	
	// Include all the users and groups
	include_once 'accounts-%_weaverfm-uniqueid_%.php';

	// Include the configuration file
	include_once 'config-%_weaverfm-uniqueid_%.php';
	
	// Include the utils file
	include_once 'utils-%_weaverfm-uniqueid_%.php';
	
	// Include the messages file
	include_once 'messages-%_weaverfm-uniqueid_%.php';
	
	// Include WFMUpload for mime type recognition
	include_once 'WFMUpload.php';
	
	require_once('class.phpmailer.php');
	
	// If the username is empty, exit
	if(!isset($_GET['wfm_uname'])) exit;
	
	// The response to feed back to the browser
	$response = array('WFM_RECOVERY_RESULT' => true);
	
	// Get the user
	$user = $_GET['wfm_uname'];
	
	// Get the properties for the user
	$properties = propertiesForUser($user);
	
	// Get the email for the user
	$destination = emailForUser($user);
	
	// The message to send
	$message = $messages['recovery'];
	
	// If the email isn't empty
	if (!empty($destination) and !empty($message)) {
		
		// Get the hashed password
		$hashed_password = $properties['hashed_password'];
		
		// Get the first name of the user
		$firstname = firstNameOfUser($user);
		
		// Get the first name of the user
		$lastname = lastNameOfUser($user);
		
		// Decrypt the password
		$decrypted_password = rot13decrypt($hashed_password);
		
		// The source
		$source = $message['sender'];
		$source_firstname = $message['firstname'];
		$source_lastname = $message['lastname'];
		
		// The message body
		$messageBody = $message['body'];
		
		// Message attachments
		$files = $message['attachments'];

		// The subject of the message
		$subject = $message['subject'];

		$keywords = array('[firstname]' => $firstname,
						  '[lastname]' => $lastname,
						  '[password]' => $decrypted_password,
						  '[date]' => date('F j, Y'),
						  '[time]' => date('G:i:s T'),
						  '[datetime]' => date('D M j Y G:i:s T')
		);

		if (!sendMessage($source,
			$source_firstname,
			$source_lastname,
			$destination,
			$firstname,
			$lastname,
			$subject,
			$messageBody,
			$files,
			$keywords)) {
			// Log an error if the email wasn't sent
			error_log('weaverFM error! Unable to send password notification to '.$destination);	
		}
	}
	
	echo(json_encode($response));
?>