<?php
	
	// Include all utility functions
	include_once 'utils-%_weaverfm-uniqueid_%.php';
	
	// Include all the users and groups
	include_once 'accounts-%_weaverfm-uniqueid_%.php';
	
	// Include the configuration script
	include_once 'config-%_weaverfm-uniqueid_%.php';

	// Set up the root data
	function init() {
		
		// Global root
		global $root;
		
		// The min version of PHP required to run weaverFM
		$min_version_required = '5.0.0';
		
		// Verify that we meet the min PHP requirement
		if(version_compare(PHP_VERSION, $min_version_required, '>=')){
		
			// Check to see if the data folder exists
			$data_folder = realpath('./'.$root);
		
			// If the data directory doesn't exist
			// or if the data directory's path is not a directory
			if(!is_dir($data_folder)){
			
				// If the folder doesn't exist then try to make it
				try {
					mkdir($data_folder, 0777);
				} catch (Exception $e) {
				
					echo '<p><b>Error PHP mkdir failed!</b></p>';
					echo '<p>PHP failed to create a folder titled '.$root.'/ to hold uploaded files.<br />
					Please create the folder '.$data_folder.' by hand using your favorite FTP application.</p><br />';
				}
			}
			
			// Check if the folder is writable
			try {
				// Try to change the permissions on the folder
				chmod($data_folder, 0777);
			} catch (Exception $e) {
				echo '<p><b>Error PHP chmod failed!</b></p>';
				echo '<p>PHP failed to change permissions a folder titled '.$root.'/ to 777.<br />
				Please change the permissions on folder '.$data_folder.' by hand using your favorite FTP application.</p><br />';
			}
			
		
			// Check if the folder is writable
			if(!is_writable($data_folder)) {
				echo '<p><b>Error folder not writable!</b></p>';
				echo '<p>PHP is unable to write to folder titled '.$root.'/.<br />
				Please set the permissions of the folder '.$data_folder.' to 777 by hand using your favorite FTP application.</p><br />';
			}
		} else {
			
			// We do not meet the min PHP requirements
			echo '<p>I am sorry weaverFM requires PHP version '.$min_version_required.' or greater.</p>';
			echo '<p>PHP version '.PHP_VERSION.' has been detected. Please upgrade your PHP installation before using weaverFM.</p>';
		}
	}
	
	// Init the group
	function initGroup($group = '') {
		
		// Global root
		global $root;
		
		// Get the home of the group
		$home = homeForGroup($group);
		
		// If the home is not empty
		if(!empty($home)) {
			
			// Check to see if the data folder exists
			$data_folder = realpath('../'.$root.'/').'/'.$home;
			
			// If the data directory doesn't exist
			// or if the data directory's path is not a directory
			if(!is_dir($data_folder)){
				
				// If the folder doesn't exist then try to make it
				try {
					mkdir($data_folder, 0777);
				} catch (Exception $e) {
					error_log('WEAVERFM ERROR: Unable to create group folder!');
				}
			}
			
			// Check if the folder is writable
			try {
				// Try to change the permissions on the folder
				chmod($data_folder, 0777);
			} catch (Exception $e) {
				echo '<p><b>Error PHP chmod failed!</b></p>';
				echo '<p>PHP failed to change permissions a folder titled '.$home.'/ to 777.<br />
				Please change the permissions on folder '.$data_folder.' by hand using your favorite FTP application.</p><br />';
			}
			
			// Check if the folder is writable
			if(!is_writable($data_folder)) {
				error_log('WEAVERFM ERROR: Group folder is not writable!');
			}
		}
	}

?>