<?php
	
	// Include all the users and groups
	include_once 'accounts-%_weaverfm-uniqueid_%.php';
	
	// Include the configuration script
	include_once 'config-%_weaverfm-uniqueid_%.php';
	
	// Include json
	include_once 'wfmjson.php';
	
	// Generate a random string
	function getRandomString($length=40){
		if(!is_int($length)||$length<1){
		    trigger_error('Invalid length for random string');
		    exit();
		}
		$chars="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
		$randstring='';
		$maxvalue=strlen($chars)-1;
		for($i=0;$i<$length;$i++){
		    $randstring.=substr($chars,rand(0,$maxvalue),1);
		}
		return $randstring;
	}
	
	// Get the session username
	function sessionUsername() {
		
		// Get the global session
		global $_SESSION;
		
		// Return the username
		return (isset($_SESSION['wfm_username']) ? $_SESSION['wfm_username'] : '');
	}
	
	// Set the session username
	function setSessionUsername($username = '') {
		
		// Get the global session
		global $_SESSION;
		$_SESSION['wfm_username'] = $username;
	}
	
	// Get the session password
	function sessionPassword() {
		
		// Get the global session
		global $_SESSION;
		
		// Return the password
		return (isset($_SESSION['wfm_password']) ? $_SESSION['wfm_password'] : '');
	}
	
	// Set the session password
	function setSessionPassword($pw = '') {
		
		// Get the global session
		global $_SESSION;
		$_SESSION['wfm_password'] = $pw;
	}
	
	// Get the session cookie
	function sessionCookie() {
		
		// Get the global session
		global $_SESSION;
		
		// Return the cookie
		return (isset($_SESSION['wfm_cookie']) ? $_SESSION['wfm_cookie'] : '');
	}
	
	// Set the session cookie
	function setSessionCookie($cookie = '') {
		
		// Get the global session
		global $_SESSION;
		$_SESSION['wfm_cookie'] = $cookie;
	}
	
	// Get the session issued on
	function sessionIssuedOn() {
		
		// Get the global session
		global $_SESSION;
		
		// Return the cookie
		return (isset($_SESSION['wfm_issued_on']) ? $_SESSION['wfm_issued_on'] : '');
	}
	
	// Set the session issued on
	function setSessionIssuedOn($issued = '') {
		
		// Get the global session
		global $_SESSION;
		$_SESSION['wfm_issued_on'] = $issued;
	}
	
	// Get the session challenge
	function sessionChallenge() {
		
		// Get the global session
		global $_SESSION;
		
		// Return the cookie
		return (isset($_SESSION['wfm_challenge']) ? $_SESSION['wfm_challenge'] : '');
	}
	
	// Set the session challenge
	function setSessionChallenge($challenge = 0) {
		
		// Set the challenge
		global $_SESSION;
		$_SESSION['wfm_challenge'] = (expired($challenge) ? time() : $challenge);
	}
	
	// Get the session autologin
	function sessionAutologin() {
		
		// Get the global session
		global $_SESSION;
		
		// Return the cookie
		return (isset($_SESSION['wfm_autologin']) ? $_SESSION['wfm_autologin'] : 0);
	}
	
	// Set the session autologin
	function setSessionAutologin($autologin = 0) {
		
		// Get the global session
		global $_SESSION;
		$_SESSION['wfm_autologin'] = $autologin;
	}
	
	// Return the properties for the specified user
	function propertiesForUser($user = '') {
		
		// The users
		global $users;
		
		// Return the user's properties
		return (userExists($user) ? $users[$user] : array());
	}
	
	// Return the properties for the specified group
	function propertiesForGroup($group = '') {
		
		// The groups
		global $groups;
		
		// Return the groups's properties
		return (groupExists($group) ? $groups[$group] : array());
	}
	
	// Return the home for the specified group
	function homeForGroup($group = '') {
		
		// Get the properties for the group
		$properties = propertiesForGroup($group);
		
		// If the flag is set
		return (isset($properties['home']) ? $properties['home'] : '');
	}
	
	// Return the users for the specified group
	function usersForGroup($group = '') {
		
		// Get the properties for the group
		$properties = propertiesForGroup($group);
		
		// If the flag is set
		return (isset($properties['users']) ? $properties['users'] : array());
	}
	
	// Return if the specified group has upload notifications enabled
	function uploadNotificationsEnabledForGroup($group = '') {
		
		// Get the properties for the group
		$properties = propertiesForGroup($group);
		
		// If the flag is set
		return (isset($properties['uploadNotifications']) ? $properties['uploadNotifications'] : false);
	}
	
	// Return if the specified group has download notifications enabled
	function downloadNotificationsEnabledForGroup($group = '') {
		
		// Get the properties for the group
		$properties = propertiesForGroup($group);
		
		// If the flag is set
		return (isset($properties['downloadNotifications']) ? $properties['downloadNotifications'] : false);
	}
	
	// Get the group for the specified user
	function groupForUser($user = '') {
		
		// Get the properties for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['group']) ? $properties['group'] : '');
	}
	
	// Get the password for the specified user
	function passwordForUser($user = '') {
		
		// Get the properties for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['password']) ? $properties['password'] : '');
	}
	
	// Get the language for the user
	function languageForUser($user = '') {
		
		// Get the properties for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['language']) ? $properties['language'] : '');
	}
	
	// Get the email for the user
	function emailForUser($user = '') {
		
		// Get the properties for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['email']) ? $properties['email'] : '');
	}
	
	// Get the first name of the user
	function firstNameOfUser($user = '') {
		
		// Get the properties for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['firstname']) ? $properties['firstname'] : '');
	}
	
	// Get the last name of the user
	function lastNameOfUser($user = '') {
		
		// Get the properties for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['lastname']) ? $properties['lastname'] : '');
	}
	
	// Return true if the user exists
	function userExists($username = '') {
		// Grab the global users
		global $users;
		
		// Return true if the user exists
		return array_key_exists($username, $users);
	}
	
	// Return true if the group exists
	function groupExists($groupname = '') {
		// Grab the global groups
		global $groups;
		
		// Return true if the group exists
		return array_key_exists($groupname, $groups);
	}
	
	// Get the upload permissions for the specified user
	function userCanUpload($user = '') {
		
		// Get the properties for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['upload']) ? $properties['upload'] : false);
	}
	
	// Get the download permissions for the specified user
	function userCanDownload($user = '') {
		
		// Get the properties for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['download']) ? $properties['download'] : false);
	}
	
	// Get the destroy permissions for the specified user
	function userCanDestroy($user = '') {
		
		// Get the properties for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['destroy']) ? $properties['destroy'] : false);
	}
	
	// Get if the user expires
	function userExpires($user = '') {
		
		// Get the properites for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['expires']) ? $properties['expires'] : false);
	}
	
	// Get if the user expires
	function userExpiresOn($user = '') {
		
		// Get the properites for the user
		$properties = propertiesForUser($user);
		
		// If the flag is set
		return (isset($properties['expiration']) ? strtotime($properties['expiration']) : 0);
	}
	
	// Get the current session array
	function sessionArray() {
		
		// Return the session
		return array('wfm_username' => username(),
					 'wfm_password' => password(),
					 'wfm_cookie' => cookie(),
					 'wfm_issued_on' => issuedOn());
	}
	
	// Set the current session array
	function setSessionArray($session = array()) {
		
		// Verify the keys exist
		if(array_key_exists('wfm_username', $session) && 
		   array_key_exists('wfm_password', $session) &&
		   array_key_exists('wfm_cookie', $session) && 
		   array_key_exists('wfm_issued_on', $session)) {
			// Set the session
			setSession($session['wfm_username'], $session['wfm_password'], $session['wfm_cookie'], $session['wfm_issued_on']);
		}
	}
	
	// Set the session variables
	function setSession($username = '', $password = '', $cookie = '', $issued_on = 0) {
		setSessionPassword($password);
		setSessionUsername($username);
		setSessionCookie($cookie);
		setSessionIssuedOn($issued_on);
	}
	
	// Return a hashed version of a string
	function hashedPassword($pw = '', $challenge = '') {
		
		// The hashed password
		// md5(pw + challenge)
		return md5($pw.$challenge.saltinator($challenge));
	}
	
	// Verify the login, password, and challenge
	function verifyLogin($username = '', $password = '', $challenge = '') {
		
		// The result
		$result = false;
		
		// Check if the user exists
		if(userExists($username) && 
		   !empty($username) &&
		   !empty($password) &&
		   !empty($challenge)) {
			
			// Get the user's password
			$user_password = passwordForUser($username);
			
			// Hash the password
			$hashed_password = hashedPassword($user_password, $challenge);
			
			// If the two passwords match
			if(strcasecmp($hashed_password, $password) === 0) {
				
				// The login is valid
				$result = true;
			}
		}
		
		// Return the result
		return $result;
	}
	
	// Return true if the session is expired (over 15 minutes old)
	function expired($distant_past = 0) {
		return (round(abs(time() - $distant_past))/60 > 15);
	}
	
	// Return true if the user account is expired
	function userExpired($user = '') {
	
		// $expiration_date is in the future as long as 
		// $expiration_date - time() is greater than 0
		return (userExpires($user) ? !((userExpiresOn($user) - time()) > 0) : false);
	}
	
	// Return true if the cookie is expired
	function cookieExpired($issued_on = 0) {
		// Use the global
		global $expiration;
		
		// First verify that the cookie is within the appropriate time frame
		// If the cookie was issued more than the prescribed days ago, exit
		$days_ago = (time() - $issued_on)/(60*60*24);
		
		// The cookie is expired if it is older than $expiration
		return ($days_ago > $expiration);
	}
	
	// Generate the cookie for the user
	function generateCookieForUser($username = '', $issued_on = 0) {
		
		// Use the global salt and expiration as defined in the config.php
		global $salt1, $salt2, $timeSalt;
		
		// The result to return
		$result = '';
		
		// Search the users array for the encrypted username
		if (userExists($username)) {
			
			// The user's password
			$pw = passwordForUser($username);
			
			// Generate the cookie
			$result = md5($username.$pw.$salt1.$issued_on.$timeSalt.$salt2);
		}
		
		// Return the result
		return $result;
	}
	
	// Get the cookies array
	function cookieArray() {
		// The result to return
		$result = array();
			
		// Add the keys to the array
		$result['wfm_cookie'] = cookieCookie();
		$result['wfm_username'] = cookieUsername();
		$result['wfm_issued_on'] = cookieIssuedOn();
		
		// Return the result
		return $result;
	}
	
	// Get the cookie username
	function cookieUsername() {
		
		// Get the global cookie
		global $_COOKIE;
		
		// Return the username
		return (isset($_COOKIE['weaverfm-%_weaverfm-uniqueid_%-wfm_username']) ? $_COOKIE['weaverfm-%_weaverfm-uniqueid_%-wfm_username'] : '');
	}
	
	// Get the cookie cookie
	function cookieCookie() {
		
		// Get the global cookie
		global $_COOKIE;
		
		// Return the username
		return (isset($_COOKIE['weaverfm-%_weaverfm-uniqueid_%-wfm_cookie']) ? $_COOKIE['weaverfm-%_weaverfm-uniqueid_%-wfm_cookie'] : '');
	}
	
	// Get the cookie issued on
	function cookieIssuedOn() {
		
		// Get the global cookie
		global $_COOKIE;
		
		// Return the username
		return (isset($_COOKIE['weaverfm-%_weaverfm-uniqueid_%-wfm_issued_on']) ? $_COOKIE['weaverfm-%_weaverfm-uniqueid_%-wfm_issued_on'] : '');
	}
	
	// Verify a cookie array
	function verifyCookieArray($anArray = array()) {
		
		// The result to return
		$result = false;
		
		// Verify that the keys exists
		if(array_key_exists('wfm_username', $anArray) && 
		   array_key_exists('wfm_issued_on', $anArray) &&
		   array_key_exists('wfm_cookie', $anArray)) {
			// Verify the cookie
			$result = verifyCookie($anArray['wfm_username'], $anArray['wfm_cookie'], $anArray['wfm_issued_on']);
		}
		
		// Return the result
		return $result;
	}
	
	// Verify a cookie
	function verifyCookie($username = '', $cookie = '', $issued_on = '') {
		
		// The result to return
		$result = false;
		
		// Use the global
		global $expiration, $salt1, $salt2, $expiration, $timeSalt;
		
		// First verify that the cookie is within the appropriate time frame
		// If the cookie was issued more than the prescribed days ago, exit
		if(!cookieExpired($issued_on)) {
		
			// Search the users array for the encrypted username
			if (userExists($username) &&
				!userExpired($username)) {
			
				// Does the user expire?
				// The user properties
				$properties = propertiesForUser($username);
				
				// The password for the user
				// md5(md5(userpassword) + challenge)
				$signed_password = $properties['password'];
				
				// Generate a signed cookie
				$signed_cookie = generateCookieForUser($username, $issued_on);
				
				// If the cookie match set the session parameters
				if(strcmp($signed_cookie, $cookie) == 0) {
					// The signed cookie and browser supplied cookie should match
					$result = true;
				}
			}
		}
		
		// Return the result
		return $result;
	}
	
	// Set the session from the cookie array
	function setSessionWithCookieArray($anArray = array()) {
		
		// Verify the keys exist
		if(array_key_exists('wfm_username', $anArray) && 
		   array_key_exists('wfm_cookie', $anArray) && 
		   array_key_exists('wfm_issued_on', $anArray)) {
			
			// If the user is valid
			if(userExists($anArray['wfm_username'])) {
				
				// Get the user properties
				$properties = propertiesForUser($anArray['wfm_username']);
				
				// Get the user password
				$pw = $properties['password'];
				
				// Add the password to the array
				$anArray['wfm_password'] = $pw;
				
				// Set the session
				setSessionArray($anArray);
			}
		}
	}
	
	// Source: http://php.net/manual/en/function.ini-get.php
	function return_bytes($val) {
	    $val = trim($val);
	    $units = strtolower(substr($val,strlen($val/1),1));
		
	    if($units == 'g')
	        $val = $val*1024*1024*1024;
	    if($units == 'm')
	        $val = $val*1024*1024;
	    if($units == 'k')
	        $val = $val*1024;
		
	    return $val;
	}
	
	// ROT-13 encryption
	// Source: http://php.net/manual/en/function.str-rot13.php
	function rot13encrypt ($str) {
		return str_rot13(base64_encode($str));
	}

	// ROT-13 decryption
	// Source: http://php.net/manual/en/function.str-rot13.php
	function rot13decrypt ($str) {
	    return base64_decode(str_rot13($str));
	}
	
	// Return a salty key for a given time
	function saltinator($now = 0) {
		global $timeSalt, $salt1, $salt2;
		return md5($timeSalt.$now.$salt1.$salt2);
	}
?>