<?php

include_once('FileManager.php');
include_once('WFMFileManager.php');

// Include all utility functions
include_once 'utils-%_weaverfm-uniqueid_%.php';

// Include all the users and groups
include_once 'accounts-%_weaverfm-uniqueid_%.php';

// Include the configuration script
include_once 'config-%_weaverfm-uniqueid_%.php';

// Include the setup script
include_once 'setup-%_weaverfm-uniqueid_%.php';

// Include the messages script
include_once 'messages-%_weaverfm-uniqueid_%.php';

// Callbacks
function UploadComplete($fromUser = '', $fileName = '', $extension = ''){
	// Get the current group
	$group = groupForUser($fromUser);
	
	// If the current group has upload notifications enabled
	if (uploadNotificationsEnabledForGroup($group)) {
		
		// Send an upload message to each user
		foreach (usersForGroup($group) as $toUser) {
			sendUploadNotificationEmail($toUser, $fileName, $extension, $fromUser);
		}
	}
}
	
function DownloadComplete($fromUser = '', $fileName = '', $extension = ''){
	// Get the current group
	$group = groupForUser($fromUser);
	
	// If the current group has upload notifications enabled
	if (downloadNotificationsEnabledForGroup($group)) {
		
		// Send an upload message to each user
		foreach (usersForGroup($group) as $toUser) {
			sendDownloadNotificationEmail($toUser, $fileName, $extension, $fromUser);
		}
	}
}

// Please add your own authentication here
function UploadIsAuthenticated($get){
	return (isset($_GET['session_username']) and isset($_GET['session_cookie']) ? 
			verifyCookie($_GET['session_username'], $_GET['session_cookie'], $_GET['session_issued_on']) and 
			userCanUpload($_GET['session_username']) : false);
}

function DownloadIsAuthenticated($get){
	return (verifyCookieArray(cookieArray()) && userCanDownload(sessionUsername()));
}

function DestroyIsAuthenticated($get){
	return (verifyCookieArray(cookieArray()) && userCanDestroy(sessionUsername()));
}

function ViewIsAuthenticated($get){
	return verifyCookieArray(cookieArray());
}

function CreateIsAuthenicated($get) {
	return verifyCookieArray(cookieArray()) && userCanUpload(sessionUsername());
}

// Get the cookies from the request
$cookie_jar = cookieArray();

// If Cookies is not set, exit
if(count($cookie_jar) == 0) exit;

if(verifyCookieArray($cookie_jar) or 
	(isset($_GET['event']) && strcmp($_GET['event'], 'upload') == 0)) {
	
	// Update the session
	setSessionWithCookieArray($cookie_jar);
	
	// Get the username
	$user = sessionUsername();
	
	// Get the group
	$group = groupForUser($user);
	
	// Init the group
	initGroup($group);
	
	// Get the base
	$base = $root.'/';
	if (strlen(homeForGroup($group)) == 0) 
	{
		if(isset($_GET['event'])) {
			if(strcmp($_GET['event'], 'upload') != 0) {
				$base = '';
			}
		}
	}
	
	$browser = new WFMFileManager(array(
		'directory' => '../'.$root.'/'.homeForGroup($group),
		'assetBasePath' => '%_weaverfm-assetpath_%/',
		'maxUploadSize' => min(return_bytes(ini_get('post_max_size')), return_bytes(ini_get('upload_max_filesize'))),
		'id3Path' => './getid3.php',
		'mimeTypesPath' => './MimeTypes.ini',
		'baseURL' => $base,
		'upload' => true,
		'destroy' => true,
		'scriptPath' => 'weaverfm-%_weaverfm-uniqueid_%.php',
	));
	
	$browser->fireEvent(!empty($_GET['event']) ? $_GET['event'] : null);
}

?>